#include <QtGui>
#include <QtCore>
// #include <QGLWidget>
#include <QtOpenGL>
#include "Figure3D.h"
#include "math.h"

Figure3D::Figure3D(QWidget* pwgt/*= 0*/) : QGLWidget(pwgt), 
                                            m_xRotate(0), 
                                            m_yRotate(0),
                                            m_zRotate(0),
                                            m_Scale(1)
{ 
//  Figure3D      pwgt 
} 

/*virtual*/void Figure3D::initializeGL() 
{

   qglClearColor(Qt::white);         //     
   glEnable(GL_DEPTH_TEST);          //       ?? 
   glShadeModel(GL_FLAT);            //    
   m_nFigure3D = createFigure3D(1.0f); //    fSize

}

/*virtual*/void Figure3D::resizeGL(int nWidth, int nHeight) 
{ 
   // glViewport(0, 0, (GLint)nWidth, (GLint)nHeight); //        
   
   glViewport((GLint)nWidth/2-(GLint)nHeight/2, 0, (GLint)nHeight, (GLint)nHeight); //  !!!      !!!
   
   glMatrixMode(GL_PROJECTION);                     //     ( ) ?? 
   glLoadIdentity();                                //      ?? 
                                                    //  
   
   // glFrustum(-0.0, 0.0, -0.0, 0.0, 0.0, 0.0);      //   
   
   //  : (, , , , , )
   
   glOrtho(-1.0, 1.0, -1.0, 1.0, -1.0, 1.0);
}

/*virtual*/void Figure3D::paintGL() 
{ 
   glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT); //   

   glMatrixMode(GL_MODELVIEW);                         //      
   glLoadIdentity();                                   //    
//    glTranslatef(0.0, 0.0, -3.0);                       //     
   
   glRotatef(m_xRotate, 1.0, 0.0, 0.0); 
   glRotatef(m_yRotate, 0.0, 1.0, 0.0); 
   glRotatef(m_zRotate, 0.0, 0.0, 1.0);
   
   glScalef(m_Scale*1.0f, m_Scale*1.0f, m_Scale*1.0f);   
   
   glCallList(m_nFigure3D);  //    glCallList       . 

} 

/*virtual*/void Figure3D::mousePressEvent(QMouseEvent* pe) 
{ 
   m_ptPosition = pe->pos(); //       m_ptPosition  
                             //     
} 

/*virtual*/void Figure3D::mouseMoveEvent(QMouseEvent* pe) 
{
   m_xRotate += 180 * (GLfloat) (pe->y() - m_ptPosition.y()) / height(); //   
   m_yRotate += 180 * (GLfloat) (pe->x() - m_ptPosition.x()) / width(); 
      
   updateGL(); //  
   
   m_ptPosition = pe->pos(); 
}

/*virtual*/void Figure3D::keyPressEvent(QKeyEvent* pe)
{
   switch (pe -> key())
   {
         case Qt::Key_Up:    m_Scale = m_Scale*1.02;
         break;
         
         case Qt::Key_Down:  m_Scale = m_Scale/1.02;
         break;
         
         case Qt::Key_Left:  m_zRotate += 2.5;
         break;
         
         case Qt::Key_Right: m_zRotate -= 2.5;
         break;
         
         case Qt::Key_Space:  //    
            m_Scale = 1;
            m_xRotate = 0;
            m_yRotate = 0;
            m_zRotate = 0;
         break;
   }

   updateGL(); //  
}

GLuint Figure3D::createFigure3D(GLfloat fSize/*=1.0f*/) 
{ 
   GLuint n = glGenLists(1); //       
                             //    ??
      
   glNewList(n, GL_COMPILE); 
 
            // pi/180=0.017453     
            GLfloat R=0.3*fSize;
                        
            GLfloat x1=R*sin(-36*0.017453);
            GLfloat y1=R*cos(-36*0.017453);
            GLfloat z1=0.15*fSize;
            
            GLfloat x2=R*sin(36*0.017453);
            GLfloat y2=R*cos(36*0.017453);
            
            GLfloat x3=R*sin((36+72)*0.017453);
            GLfloat y3=R*cos((36+72)*0.017453);
            
            GLfloat x4=R*sin((36+2*72)*0.017453);
            GLfloat y4=R*cos((36+2*72)*0.017453);
            
            GLfloat x5=R*sin((36+3*72)*0.017453);
            GLfloat y5=R*cos((36+3*72)*0.017453);
            
            GLfloat x6=R*sin((36+4*72)*0.017453);
            GLfloat y6=R*cos((36+4*72)*0.017453);
            
            GLfloat A=R*sqrt(2-2*cos(72*0.017453));
            GLfloat B=A*tan(72*0.017453)/2;
            GLfloat C=R*cos(36*0.017453)+B;
            GLfloat z2=B/C*z1;
            
            
            //            
            glBegin(GL_TRIANGLE_FAN);
               glColor4f(0.70f, 0.25f, 0.25f, 1.0f);
               glVertex3f(0, 0,   z1); 
               glVertex3f(x1, y1, z2);
               glVertex3f(x2, y2, z2);
               
               glColor4f(0.65f, 0.25f, 0.25f, 1.0f);
               glVertex3f(x3, y3, z2);
               
               glColor4f(0.55f, 0.25f, 0.25f, 1.0f);
               glVertex3f(x4, y4, z2);
               
               glColor4f(0.60f, 0.25f, 0.25f, 1.0f);
               glVertex3f(x5, y5, z2);
               
               glColor4f(0.65f, 0.25f, 0.25f, 1.0f);
               glVertex3f(x6, y6, z2);             
            glEnd();
            
            //   
            glBegin(GL_TRIANGLE_FAN);
               glColor4f(0.70f, 0.25f, 0.25f, 1.0f);
               glVertex3f(0, 0,   -z1); 
               glVertex3f(x1, y1, -z2);
               glVertex3f(x2, y2, -z2);
               
               glColor4f(0.65f, 0.25f, 0.25f, 1.0f);
               glVertex3f(x3, y3, -z2);
               
               glColor4f(0.55f, 0.25f, 0.25f, 1.0f);
               glVertex3f(x4, y4, -z2);
               
               glColor4f(0.60f, 0.25f, 0.25f, 1.0f);
               glVertex3f(x5, y5, -z2);
               
               glColor4f(0.65f, 0.25f, 0.25f, 1.0f);
               glVertex3f(x6, y6, -z2);             
            glEnd(); 
                     
            GLfloat x12=0;
            GLfloat y12=C;
            
            GLfloat x23=C*sin(72*0.017453);
            GLfloat y23=C*cos(72*0.017453);
            
            GLfloat x34=C*sin(2*72*0.017453);
            GLfloat y34=C*cos(2*72*0.017453);
            
            GLfloat x45=C*sin(3*72*0.017453);
            GLfloat y45=C*cos(3*72*0.017453);
            
            GLfloat x56=C*sin(4*72*0.017453);
            GLfloat y56=C*cos(4*72*0.017453);
            
            //     ()
            glBegin(GL_TRIANGLE_FAN);
               glColor4f(0.70f, 0.25f, 0.25f, 1.0f);
               glVertex3f(x12, y12, 0);
               glVertex3f(x1,  y1,  z2);
               glVertex3f(x2,  y2,  z2);  
               
               glColor4f(0.65f, 0.0f, 0.0f, 1.0f);
               glVertex3f(x2,  y2, -z2);
               
               glColor4f(0.70f, 0.25f, 0.25f, 1.0f);
               glVertex3f(x1,  y1, -z2);
               
               glColor4f(0.60f, 0.0f, 0.0f, 1.0f);
               glVertex3f(x1,  y1,  z2);           
            glEnd(); 
            
            //     (    )
            glBegin(GL_TRIANGLE_FAN);
               glColor4f(0.65f, 0.25f, 0.25f, 1.0f);
               glVertex3f(x23, y23, 0);
               glVertex3f(x2,  y2,  z2); 
               glVertex3f(x3,  y3,  z2);   
               
               glColor4f(0.55f, 0.0f, 0.0f, 1.0f);
               glVertex3f(x3,  y3, -z2);  
               
               glColor4f(0.65f, 0.25f, 0.25f, 1.0f);
               glVertex3f(x2,  y2, -z2);
               
               glColor4f(0.60f, 0.0f, 0.0f, 1.0f);
               glVertex3f(x2,  y2,  z2);          
            glEnd(); 
            
            //     (     )
            glBegin(GL_TRIANGLE_FAN);
               glColor4f(0.55f, 0.25f, 0.25f, 1.0f);
               glVertex3f(x34, y34, 0);
               glVertex3f(x3,  y3,  z2);            
               glVertex3f(x4,  y4,  z2);
               
               glColor4f(0.55f, 0.0f, 0.0f, 1.0f);
               glVertex3f(x4,  y4, -z2);  
               
               glColor4f(0.55f, 0.25f, 0.25f, 1.0f);
               glVertex3f(x3,  y3, -z2);
               
               glColor4f(0.50f, 0.0f, 0.0f, 1.0f);
               glVertex3f(x3,  y3,  z2);                
            glEnd();
            
            //     (     )
            glBegin(GL_TRIANGLE_FAN);
               glColor4f(0.60f, 0.25f, 0.25f, 1.0f);
               glVertex3f(x45, y45, 0);         
               glVertex3f(x4,  y4,  z2);
               glVertex3f(x5,  y5,  z2);
               
               glColor4f(0.65f, 0.0f, 0.0f, 1.0f);
               glVertex3f(x5,  y5, -z2);  
               
               glColor4f(0.60f, 0.25f, 0.25f, 1.0f);
               glVertex3f(x4,  y4, -z2);     
               
               glColor4f(0.60f, 0.0f, 0.0f, 1.0f);
               glVertex3f(x4,  y4,  z2);                           
            glEnd();
             
            //      (    )      
            glBegin(GL_TRIANGLE_FAN);
               glColor4f(0.65f, 0.25f, 0.25f, 1.0f);
               glVertex3f(x56, y56, 0);         
               glVertex3f(x5,  y5,  z2);
               glVertex3f(x6,  y6,  z2);
               
               glColor4f(0.75f, 0.0f, 0.0f, 1.0f);
               glVertex3f(x6,  y6, -z2);
               
               glColor4f(0.65f, 0.25f, 0.25f, 1.0f);
               glVertex3f(x5,  y5, -z2); 
                
               glColor4f(0.70f, 0.0f, 0.0f, 1.0f);
               glVertex3f(x5,  y5,  z2);                
            glEnd();
         
   glEndList(); 

return n; 
} 